#!ruby -Ks
# т܃TvQ[
require 'dxruby'

# `Փ˔
class CollisionBox
  attr_accessor :del, :obj, :x1, :y1, :x2, :y2, :x, :y

  # B??_offsetɂ̓Ľ_͈͍̔WiƉEjZbg
  def initialize(obj, x1, y1, x2, y2)
    @obj = obj
    @x1_offset = x1
    @y1_offset = y1
    @x2_offset = x2
    @y2_offset = y2
    @del = false
  end

  # L̍WZbg
  def set(x, y)
    @x1 = x + @x1_offset
    @y1 = y + @y1_offset
    @x2 = x + @x2_offset
    @y2 = y + @y2_offset
    @del = false
  end

  # ͈͍폜B̎sȍ~͔肪ȗ
  def delete
    @del = true
  end
end

# Փ˔胂W[
module Collision
  def self.check(a, b)
    # z񂶂ȂƂ͂Ƃ肠z
    a = [a] if a.class != Array
    b = [b] if b.class != Array

    # U[v
    a.each do |o|
      next if o.del # Ă牽Ȃ

      # h䑤[v
      b.each do |d|
        next if d.del # Ă牽Ȃ
        if o.x1 <= d.x2 and o.y1 <= d.y2 and o.x2 >= d.x1 and o.y2 >= d.y1
          o.obj.shot(d.obj) if o.obj != nil # Ushot\bhĂ
          d.obj.hit(o.obj)  if d.obj != nil # h䑤hit\bhĂ
        end
        break if o.del # U烋[vI
      end
    end
  end
end

# wi`
class Map
  attr_accessor :delete
  @@map = [[0, 0, 0, 0, 0, 0, 0, 0, 29, 11, 11, 30, 34, 66, 67, 67],
           [0, 0, 0, 24, 25, 26, 0, 0, 29, 11, 11, 39, 40, 6, 34, 34],
           [0, 0, 24, 17, 31, 35, 0, 0, 12, 20, 11, 11, 11, 39, 40, 40],
           [0, 24, 17, 34, 7, 44, 0, 28, 28, 29, 11, 11, 11, 11, 11, 11],
           [0, 33, 31, 34, 35, 0, 28, 3, 37, 38, 11, 11, 11, 18, 19, 19],
           [0, 42, 43, 43, 44, 28, 3, 38, 11, 11, 11, 18, 19, 13, 28, 28],
           [0, 0, 0, 0, 3, 37, 38, 11, 11, 18, 19, 13, 28, 28, 28, 0],
           [0, 0, 0, 3, 38, 11, 11, 11, 18, 13, 28, 28, 51, 52, 52, 52],
           [0, 0, 3, 38, 11, 11, 18, 19, 13, 51, 52, 52, 86, 58, 61, 76],
           [28, 0, 29, 11, 11, 18, 13, 28, 51, 86, 58, 58, 61, 61, 58, 62],
           [0, 28, 29, 11, 18, 13, 28, 0, 60, 58, 61, 61, 61, 61, 76, 71],
           [0, 28, 29, 11, 27, 28, 28, 51, 86, 61, 61, 58, 76, 70, 71, 0],
           [0, 0, 29, 11, 36, 4, 28, 60, 58, 61, 58, 76, 71, 0, 1, 2],
           [0, 28, 29, 11, 11, 36, 4, 69, 70, 70, 70, 71, 0, 1, 2, 0],
           [0, 0, 12, 20, 11, 11, 27, 0, 1, 0, 1, 1, 1, 2, 2, 0],
           [0, 0, 28, 12, 20, 11, 27, 0, 0, 0, 2, 2, 0, 2, 2, 0],
           [0, 0, 0, 2, 29, 11, 27, 1, 2, 2, 2, 0, 0, 2, 2, 2],
           [0, 0, 0, 2, 29, 11, 27, 1, 0, 1, 1, 2, 2, 0, 0, 2],
           [0, 0, 0, 0, 29, 11, 27, 1, 0, 2, 2, 2, 1, 1, 2, 2],
           [0, 45, 47, 2, 29, 11, 36, 4, 1, 2, 2, 0, 0, 2, 2, 0],
           [45, 82, 56, 0, 29, 11, 11, 36, 4, 1, 2, 2, 2, 2, 0, 0],
           [54, 0, 56, 0, 12, 20, 11, 11, 36, 37, 4, 0, 2, 2, 2, 2],
           [54, 55, 81, 46, 47, 12, 20, 11, 11, 11, 36, 4, 1, 1, 1, 2],
           [54, 55, 0, 0, 56, 0, 12, 19, 20, 11, 11, 36, 37, 4, 1, 1],
           [54, 0, 55, 55, 56, 0, 0, 0, 12, 20, 11, 11, 11, 36, 37, 37],
           [63, 73, 55, 55, 56, 0, 0, 2, 2, 29, 11, 11, 11, 11, 11, 11],
           [0, 54, 0, 55, 81, 47, 0, 2, 3, 38, 11, 11, 11, 11, 11, 11],
           [0, 54, 0, 0, 55, 56, 2, 0, 29, 11, 11, 11, 21, 22, 22, 22],
           [0, 63, 64, 64, 64, 65, 0, 0, 29, 11, 11, 21, 15, 48, 49, 49],
           [0, 0, 0, 0, 0, 0, 0, 0, 29, 11, 11, 30, 34, 57, 34, 34],
          ]
  temp = Image.load("image/maptile.png")
  x = temp.width / 32
  y = temp.height / 32
  @@image = Image.loadToArray("image/maptile.png", x, y)

  # 
  def initialize
    @y = 14         # }bv̏ʒu
    @count = 32     # 1`bvԂړt[
    @delete = false # 邱Ƃ͖ObjectGroupɓ邽߂ɕKv
  end

  # }bvXV
  def update
    @count -= 1

    # 1`bvԂXN[ꍇ
    if @count < 0
      @count += 32
      @y -= 1
      @y += 30 if @y < 0
    end
  end

  # }bv`
  def draw
    x = ($myship.x / 5) # @̈ړɍ킹ĉɂY
    Window.drawTile(0, 0, @@map, @@image, x, @y * 32 + @count, 12, 16, 0)
  end
end

# GP̂ꏈ
class Enemy1bomb
  @@image0 = Image.loadToArray("image/enemy1bomb.png", 4, 2)
  @@image1 = Array.new(8) {Image.new(48, 48)}      # TCY̓摜
  black = [128, 0, 0, 0]
  for i in 0..7
    for y in 0..47
      for x in 0..47
        @@image1[i][x, y] = black if @@image0[i][x, y][0] == 255 # 摜œȂɂ
      end
    end
  end
  attr_accessor :delete

  # CX^X
  def initialize(x, y)
    @x = x
    @y = y
    @delete = false
    @count = 0
  end

  # XV
  def update
    @x += $myship.delta_x
    @y += 1.5
    @count += 1
    if @y > 480 or @count >= 40
      @delete = true
      return
    end
  end

  # `
  def draw
    Window.draw(@x, @y, @@image0[@count / 5], 10)
    Window.draw(@x-16, @y-16, @@image1[@count / 5], 1)
  end
end

# GQ̂ꏈ
class Enemy2bomb
  @@image0 = Image.loadToArray("image/enemy2bomb.png", 4, 2)
  @@image1 = Array.new(8) {Image.new(128, 64)}      # TCY̓摜
  black = [128, 0, 0, 0]
  for y in 0..63
    for x in 0..127
      if @@image0[0][x, y][0] == 255 # 摜œȂɂ
        @@image1[0][x, y] = black
        @@image1[1][x, y] = black
      end
      if @@image0[2][x, y][0] == 255 # 摜œȂɂ
        @@image1[2][x, y] = black
        @@image1[3][x, y] = black
      end
    end
  end
  attr_accessor :delete

  # CX^X
  def initialize(x, y)
    @x = x
    @y = y
    @delete = false
    @count = 0
  end

  # XV
  def update
    @x += $myship.delta_x
    @y += 0.5
    @count += 1
    if @count >= 40
      @delete = true
      return
    end
  end

  # `
  def draw
    Window.draw(@x, @y, @@image0[@count / 5], 10)
    Window.draw(@x-16, @y-16, @@image1[@count / 5], 1)
  end
end

# GPpVbgqbg
class EnemyShot1Hit
  @@image = Image.load("image/enemyshot1.png")
  attr_accessor :delete

  # CX^X
  def initialize(x, y, angle)
    @x = x
    @y = y
    temp2 = angle + 180
    @dx = Math.cos((temp2) / 180.0 * Math::PI)
    @dy = Math.sin((temp2) / 180.0 * Math::PI)

    @alpha = 255
    @delete = false
  end

  # XV
  def update
    @x += $myship.delta_x
    @x += @dx
    @y += @dy
    @alpha -= 10
    if @x < -16 or @x > 360 or @y < -16 or @y > 480 or @alpha < 0
      @delete = true
    end
  end

  def draw
    Window.drawAlpha(@x, @y, @@image, @alpha, 20)
  end
end

# GPpVbg
class EnemyShot1
  @@image = Image.load("image/enemyshot1.png")
  attr_accessor :delete
  @@sound = Array.new(3) do
    v = 60
    SoundEffect.new(60,WAVE_TRI) do
      v = v - 1
      [800, v]
    end
  end
  @@soundnumber = 0
  @@soundflag = false

  # CX^X
  def initialize(x, y, angle)
    @x = x
    @y = y
    @dx = Math.cos(angle / 180.0 * Math::PI)
    @dy = Math.sin(angle / 180.0 * Math::PI)
    @collision = CollisionBox.new(self, 4, 4, 11, 11)
    @delete = false
    @angle = angle
  end

  # XV
  def update
    @x += $myship.delta_x
    @x += @dx * 1.5
    @y += @dy * 1.5
    if @x < -16 or @x > 360 or @y < -16 or @y > 480
      @delete = true
    else
      @collision.set(@x, @y)
      Collision_EnemyShot.push(@collision)
    end
    @@soundflag = false
  end

  def shot(obj)
    @delete = true
    @collision.delete
    ObjectGroup.push(EnemyShot1Hit.new(@x, @y, @angle))
    if @@soundflag == false
      @@sound[@@soundnumber].play
      @@soundnumber += 1
      @@soundnumber = 0 if @@soundnumber > 2
      @@soundflag = true
    end
  end

  # `
  def draw
    Window.draw(@x, @y, @@image, 20)
  end
end

# GQpVbgqbg
class EnemyShot2Hit
  @@image = Image.load("image/enemyshot2.png")
  attr_accessor :delete

  # CX^X
  def initialize(x, y, angle)
    @x = x # xW
    @y = y # yW
    temp2 = angle + 180
    @dx = Math.cos((temp2) / 180.0 * Math::PI) * 3.5
    @dy = Math.sin((temp2) / 180.0 * Math::PI) * 3.5
    @alpha = 255    # At@l
    @delete = false # true
  end

  # XV
  def update
    # ړ
    @x += $myship.delta_x
    @x += @dx
    @y += @dy

    # ʊO
    if @x < -24 or @x > 360 or @y < -24 or @y > 480 or @alpha < 0
      @delete = true
      return
    end

    # 
    @alpha -= 10
  end

  # `
  def draw
    Window.drawAlpha(@x, @y, @@image, @alpha, 20)
  end
end

# GQpVbg
class EnemyShot2
  @@image = Image.load("image/enemyshot2.png")
  attr_accessor :delete
  v = 60
  @@sound = Array.new(3) do
    v = 60
    SoundEffect.new(60,WAVE_TRI) do
      v = v - 1
      [600, v]
    end
  end
  @@soundnumber = 0
  @@soundflag = false

  # CX^X
  def initialize(x, y, angle)
    @x = x
    @y = y
    @dx = Math.cos(angle / 180.0 * Math::PI) * 3.5
    @dy = Math.sin(angle / 180.0 * Math::PI) * 3.5
    @collision = CollisionBox.new(self, 6, 6, 17, 17)
    @delete = false
    @angle = angle
  end

  # XV
  def update
    # ړ
    @x += $myship.delta_x
    @x += @dx
    @y += @dy

    # ʊO
    if @x < -24 or @x > 360 or @y < -24 or @y > 480
      @delete = true
      return
    end

    # Փ˔͈͐ݒ
    @collision.set(@x, @y)
    Collision_EnemyShot.push(@collision)

    @@soundflag = false
  end

  # @ɓƂɌĂ΂郁\bh
  def shot(obj)
    @delete = true
    @collision.delete
    ObjectGroup.push(EnemyShot2Hit.new(@x, @y, @angle))
    if @@soundflag == false
      @@sound[@@soundnumber].play
      @@soundnumber += 1
      @@soundnumber = 0 if @@soundnumber > 2
      @@soundflag = true
    end
  end

  # `
  def draw
    Window.draw(@x, @y, @@image, 20)
  end
end

# GP
class Enemy1
  # 摜ǂݍ݁tbV/e摜
  image0 = Image.loadToArray("image/enemy1.png", 4, 1)  # ǂݍ
  image1 = Array.new(4) {Image.new(48, 48)}      # TCY̓摜
  image2 = Array.new(4) {Image.new(48, 48)}
  white = [255, 200, 200, 200]
  black = [128, 0, 0, 0]
  for i in 0..3
    for y in 0..47
      for x in 0..47
        image1[i][x, y] = white if image0[i][x, y][0] != 0 # 摜œȂ𔒂ɂ
        image2[i][x, y] = black if image0[i][x, y][0] != 0 # 摜œȂɂ
      end
    end
  end
  @@image = [image0, image1, image2]

  # SoundEffectłʉBR܂ł̑dĐł悤z񉻁B
  @@sound = Array.new(3) do
    v = 60
    f = 500
    SoundEffect.new(120,WAVE_SAW) do
      v = v - 0.5
      f = f - 1
      [f, v]
    end
  end
  @@soundnumber = 0
  @@soundflag = false

  attr_accessor :delete

  # CX^X
  def initialize(x, y)
    @x = x  # xW
    @y = y  # yW
    @collision = CollisionBox.new(self, 0, 0, 47, 47) # Փ˔IuWFNg
    @hp = 15         # qbg|Cg
    @delete = false  # true
    @shotcount = 0   # eԊu𑪂JE^
    @imagenumber = 0 # e1(tbV\)
    @animecount = 0  # Aj[VpJE^
  end

  # XV
  def update
    # ړ
    @x += $myship.delta_x
    @y += 2
    if @y > 480
      @delete = true
      return
    end

    # e
    @shotcount += 1
    if @shotcount > 40
      # pxvZ
      angle = (Math.atan2($myship.y + 16 - (@y + 24 + 8), $myship.x + 16 - (@x + 16 + 8)) / Math::PI * 180)

      # e
      ObjectGroup.push(EnemyShot1.new(@x + 16, @y + 24, angle))

      # JEg
      @shotcount = 0
    end

    # Փ˔ݒ
    @collision.set(@x, @y)
    Collision_Enemy.push(@collision)

    # Ƃ肠t[AtbVĂȂԂɂ
    @imagenumber = 0

    # Aj[VpJEg
    @animecount += 1
    @animecount -= 80 if @animecount >= 80

    @@soundflag = false
  end

  # @VbgɓƂɌĂ΂郁\bh
  def hit(obj)
    # HP炷
    @hp = @hp - obj.damage

    # ꏈ
    if @hp <= 0
      @delete = true
      @collision.delete
      ObjectGroup.push(Enemy1bomb.new(@x, @y))

      # ʉ̑dĐ
      if @@soundflag == false
        @@sound[@@soundnumber].play
        @@soundnumber += 1
        @@soundnumber = 0 if @@soundnumber > 2
        @@soundflag = true
      end
    end

    # tbVɂ
    @imagenumber = 1
  end

  def draw
    Window.draw(@x, @y, @@image[@imagenumber][@animecount / 20], 10)
    Window.draw(@x-16, @y-16, @@image[2][@animecount / 20], 1)
  end
end

# GQ
class Enemy2
  # 摜ǂݍ݁tbV/e摜
  image0 = Image.loadToArray("image/enemy2.png", 4, 1)  # ǂݍ
  image1 = Array.new(4) {Image.new(128, 64)} # TCY̓摜
  image2 = Array.new(4) {Image.new(128, 64)}
  white = [255, 200, 200, 200]
  black = [128, 0, 0, 0]
  for i in 0..3
    for y in 0..63
      for x in 0...127
        image1[i][x, y] = white if image0[i][x, y][0] != 0 # 摜œȂ𔒂ɂ
        image2[i][x, y] = black if image0[i][x, y][0] != 0 # 摜œȂɂ
      end
    end
  end
  @@image = [image0, image1, image2]
  v = 80
  @@sound = SoundEffect.new(4000,WAVE_RECT, 5000) do
    v = v - 0.03
    [rand(300), v]
  end
  attr_accessor :delete

  # CX^X
  def initialize(x, y)
    @x = x   # xW
    @y = y   # yW
    @dy = 10 # cړ
    @collision = CollisionBox.new(self, 0, 0, 127, 63) # Փ˔IuWFNg
    @hp = 400 # qbg|Cg
    @delete = false  # true
    @shotcount = 0   # eԊu𑪂JE^
    @imagenumber = 0 # e1(tbV\)
    @animecount = 0  # Aj[VpJE^
  end

  # XV
  def update
    # ړ
    @x += $myship.delta_x
    @y += @dy

    # ʊO
    if @y < -64
      @delete = true
      return
    end

    if @dy > 0         # Ɉړ
      @dy -= 0.3         # 
    else               # ړĂ
      @shotcount += 1    # VbgJEg𑫂
      if @shotcount > 60 # JEg60𒴂e
        # pxvZ
        angle = (Math.atan2($myship.y + 16 - (@y + 40 + 12), $myship.x + 16 - (@x + 56 + 12)) / Math::PI * 180)
        # 5
        ObjectGroup.push(EnemyShot2.new(@x + 56, @y + 40, angle - 45))
        ObjectGroup.push(EnemyShot2.new(@x + 56, @y + 40, angle - 22.5))
        ObjectGroup.push(EnemyShot2.new(@x + 56, @y + 40, angle))
        ObjectGroup.push(EnemyShot2.new(@x + 56, @y + 40, angle + 22.5))
        ObjectGroup.push(EnemyShot2.new(@x + 56, @y + 40, angle + 45))
        # JEg
        @shotcount = 0
      end
    end

    # Ƃ肠t[AtbVĂȂԂɂ
    @imagenumber = 0

    # Փ˔ݒ
    @collision.set(@x, @y)
    Collision_Enemy.push(@collision)

    # Aj[VpJEg
    @animecount += 1
    @animecount -= 40 if @animecount >= 40
  end

  # @VbgƂɌĂ΂郁\bh
  def hit(obj)
    # HP炷
    @hp = @hp - obj.damage

    # ꏈ
    if @hp <= 0
      @delete = true
      @collision.delete
      ObjectGroup.push(Enemy2bomb.new(@x, @y))
      @@sound.play
    end

    # tbVɂ
    @imagenumber = 1
  end

  # `
  def draw
    Window.draw(@x, @y, @@image[@imagenumber][@animecount / 10], 10) # G
    Window.draw(@x-16, @y-16, @@image[2][@animecount / 10], 1)       # e
  end
end

# @pVbg
class MyShot
  @@image = Image.load("image/myshot.png")
  attr_accessor :delete, :damage

  # CX^X
  def initialize(x, y, angle)
    @x = x   # xW
    @y = y   # yW
    @dx = Math.cos(angle / 180.0 * Math::PI) # ړ
    @dy = Math.sin(angle / 180.0 * Math::PI) # cړ
    @collision = CollisionBox.new(self, 0, 0, 31, 31) # Փ˔IuWFNg
    @delete = false # VbgƂtrue
    @damage = 5     # GɓƂɗ^_[W
    @angle = angle  # px
  end

  # XV
  def update
    # Vbgړ
    @x += @dx * 16
    @y += @dy * 16

    # ʊO
    if @x < -32 or @x > 360 or @y < -32
      @delete = true                       # ʊOȂ
    else
      @collision.set(@x, @y)               # ʓȂ画͈͈ړ
      Collision_MyShot.push(@collision)    # ͈͂̔zɒǉ
    end
  end

  # GɓƂɌĂ΂郁\bh
  def shot(obj)
    @delete = true
    @collision.delete
  end

  # `
  def draw
    Window.drawRot(@x, @y, @@image, @angle + 90, nil, nil, 15)
  end
end

# @
class MyShip
  attr_accessor :x, :y, :collision, :delta_x, :delete

  # 摜ǂݍ݂Ɖe摜
  @@image0 = Image.loadToArray("image/myship.png", 4, 1)
  @@image1 = Array.new(4) {Image.new(32, 32)}
  black = [128, 0, 0, 0]
  for i in 0..3
    for y in 0..31
      for x in 0..31
        # 摜œȂɂ
        @@image1[i][x, y] = black if @@image0[i][x, y][0] != 0
      end
    end
  end

  # Vbg
  f = 4000
  @@sound = SoundEffect.new(20, WAVE_TRI) do   # 20ms ̎Opg𐶐
    f = f - 120      # g 4000Hz  1ms Ƃ 120Hz 
    [f, 15]          # [ g,  ] ̔zԂ
  end

  # 
  def initialize
    @x = 140          # x W
    @y = 400          # y W
    @oldx = 140       # Ot[xW
    @delete = false   # @Ƃ true
    @animecount = 0   # Aj[VpJEg
    @collision = CollisionBox.new(nil, 4, 4, 27, 27)  # Փ˔IuWFNg
  end

  def update
    # ړ
    dx = Input.x * 2.4
    dy = Input.y * 3
    if Input.x != 0 and Input.y != 0   # ii̎ 0.7 {
      dx *= 0.7
      dy *= 0.7
    end
    @x += dx
    @y += dy

    # ʒ[̔
    @x = 0 if @x < 0
    @x = 360 - 32 if @x > 360 - 32
    @y = 0 if @y < 0
    @y = 480 - 32 if @y > 480 - 32

    # Փ˔͈͂̈ړ
    @collision.set(@x, @y)

    # Vbg
    if Input.padPush?(P_BUTTON0)
      ObjectGroup.push(MyShot.new(@x - 18, @y - 32, 270))
      ObjectGroup.push(MyShot.new(@x + 18, @y - 32, 270))
      ObjectGroup.push(MyShot.new(@x + 32, @y - 16, 300))
      ObjectGroup.push(MyShot.new(@x - 32, @y - 16, 240))
      @@sound.play
    end

    # wiGȂǂ̉␳lvZ
    @delta_x = -((@x - @oldx) / 5)
    @oldx = @x

    # Aj[VpJEg
    @animecount += 1
    @animecount -= 80 if @animecount >= 80
  end

  # `
  def draw
    Window.draw(@x, @y, @@image0[@animecount / 20], 15)           # @
    Window.draw(@x - 16, @y - 16, @@image1[@animecount / 20], 1)  # e
  end
end

# ܂łNX`

# 炪Q[̃C

Window.caption = "тܗp DXRuby TvQ[" # EBhẼLvVݒ
Window.width = 360        # EBhẺTCYݒ
Window.height = 480       # EBhȄcTCYݒ
Input.setRepeat(0, 5)     # L[̃I[gs[gݒB5 t[ 1  on

ObjectGroup = []          # IuWFNgz
Collision_MyShot = []     # e͈͔̔z
Collision_Enemy = []      # G͈͔̔z
Collision_EnemyShot = []  # G̒e͈͔̔z

count = 0                 # GopJEg
font = Font.new(32)       # tHg

$myship = MyShip.new      # @
ObjectGroup.push($myship) # @IuWFNgzɒǉ
ObjectGroup.push(Map.new) # wiIuWFNgIuWFNgzɒǉ

# C[v
Window.loop do

  # Go
  count += 1
  if count % 20 == 0      #  20 JEg 1 
    if count % 400 == 0   # 400 JEg 1 
      # G 2 ̃IuWFNgIuWFNgzɒǉ
      ObjectGroup.push(Enemy2.new(rand(240), -64))
      count = 0
    else
      # G 1 ̃IuWFNgIuWFNgzɒǉ
      ObjectGroup.push(Enemy1.new(rand(320), -48))
    end
  end

  # IuWFNgXV
  ObjectGroup.each do |obj|
    obj.update
  end

  # Փ˔
  Collision.check(Collision_MyShot, Collision_Enemy)      # @VbgƓG
  Collision.check(Collision_EnemyShot, $myship.collision) # GVbgƎ@

  # Փ˔z񏉊
  Collision_MyShot.clear
  Collision_Enemy.clear
  Collision_EnemyShot.clear

  # ړՓ˔ŏLz񂩂폜
  ObjectGroup.delete_if do |obj|
    obj.delete
  end

  # IuWFNg`
  ObjectGroup.each do |obj|
    obj.draw
  end

  # Esc L[ŏI
  break if Input.keyPush?(K_ESCAPE)

  # eo
  Window.drawFont(0, 0, Window.getLoad.to_i.to_s + " %", font, :z => 100)
  Window.drawFont(0, 32, ObjectGroup.size.to_s + " objects", font, :z => 100)
end
